"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Snap = exports.SS_DEV_COOKIE = exports.BRANCH_COOKIE = void 0;
var jsx_runtime_1 = require("preact/jsx-runtime");
var deepmerge_1 = __importDefault(require("deepmerge"));
var is_plain_object_1 = require("is-plain-object");
var preact_1 = require("preact");
var snap_client_1 = require("@searchspring/snap-client");
var snap_logger_1 = require("@searchspring/snap-logger");
var snap_tracker_1 = require("@searchspring/snap-tracker");
var snap_toolbox_1 = require("@searchspring/snap-toolbox");
var snap_toolbox_2 = require("@searchspring/snap-toolbox");
var snap_controller_1 = require("@searchspring/snap-controller");
var createSearchController_1 = __importDefault(require("./create/createSearchController"));
exports.BRANCH_COOKIE = 'ssBranch';
exports.SS_DEV_COOKIE = 'ssDev';
var COMPONENT_ERROR = "Uncaught Error - Invalid value passed as the component.\nThis usually happens when you pass a JSX Element, and not a function that returns the component, in the snap config. \n\t\t\n\t\tinstead of - \n\n\ttargeters: [\n\t\t{\n\t\t\tselector: '#searchspring-content',\n\t\t\thideTarget: true,\n\t\t\tcomponent: <Content/>,\n\t\t},\n\t]\n\n\t\tor - \n\n\ttargeters: [\n\t\t{\n\t\t\tselector: '#searchspring-content',\n\t\t\thideTarget: true,\n\t\t\tcomponent: Content,\n\t\t},\n\t]\n\n\t\tplease try - \n\n\ttargeters: [\n\t\t{\n\t\t\tselector: '#searchspring-content',\n\t\t\thideTarget: true,\n\t\t\tcomponent: () => Content\n\t\t},\n\t]\n\nThe error above happened in the following targeter in the Snap Config";
var Snap = /** @class */ (function () {
    function Snap(config, services) {
        var _this = this;
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        this.getInstantiator = function (id) {
            return _this._instantiatorPromises[id] || Promise.reject("getInstantiator could not find instantiator with id: ".concat(id));
        };
        this.getController = function (id) {
            return _this._controllerPromises[id] || Promise.reject("getController could not find controller with id: ".concat(id));
        };
        this.getControllers = function () {
            var controllerIds = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                controllerIds[_i] = arguments[_i];
            }
            var getControllerPromises = [];
            controllerIds.forEach(function (id) { return getControllerPromises.push(_this.getController(id)); });
            return Promise.all(getControllerPromises);
        };
        this.createController = function (type, config, services, urlConfig, context, callback) { return __awaiter(_this, void 0, void 0, function () {
            var importPromise, creationFunc;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        switch (type) {
                            case snap_controller_1.ControllerTypes.search:
                                importPromise = Promise.resolve().then(function () { return __importStar(require('./create/createSearchController')); });
                                break;
                            case snap_controller_1.ControllerTypes.autocomplete:
                                importPromise = Promise.resolve().then(function () { return __importStar(require('./create/createAutocompleteController')); });
                                break;
                            case snap_controller_1.ControllerTypes.finder:
                                importPromise = Promise.resolve().then(function () { return __importStar(require('./create/createFinderController')); });
                                break;
                            case snap_controller_1.ControllerTypes.recommendation:
                                importPromise = Promise.resolve().then(function () { return __importStar(require('./create/createRecommendationController')); });
                                break;
                        }
                        return [4 /*yield*/, importPromise];
                    case 1:
                        creationFunc = (_a.sent()).default;
                        if (!this.controllers[config.id]) {
                            this.controllers[config.id] = creationFunc({
                                url: (0, deepmerge_1.default)(this.config.url || {}, urlConfig || {}),
                                controller: config,
                                context: (0, deepmerge_1.default)(this.context || {}, context || {}),
                            }, {
                                client: (services === null || services === void 0 ? void 0 : services.client) || this.client,
                                store: services === null || services === void 0 ? void 0 : services.store,
                                urlManager: services === null || services === void 0 ? void 0 : services.urlManager,
                                eventManager: services === null || services === void 0 ? void 0 : services.eventManager,
                                profiler: services === null || services === void 0 ? void 0 : services.profiler,
                                logger: services === null || services === void 0 ? void 0 : services.logger,
                                tracker: (services === null || services === void 0 ? void 0 : services.tracker) || this.tracker,
                            });
                        }
                        if (!callback) return [3 /*break*/, 3];
                        return [4 /*yield*/, callback(this.controllers[config.id])];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/, this.controllers[config.id]];
                }
            });
        }); };
        this.config = config;
        this.logger = (services === null || services === void 0 ? void 0 : services.logger) || new snap_logger_1.Logger('Snap Preact ');
        var globalContext = {};
        try {
            // get global context
            globalContext = (0, snap_toolbox_2.getContext)(['shopper', 'config']);
        }
        catch (err) {
            this.logger.error('failed to find global context');
        }
        // merge configs - but only merge plain objects
        this.config = (0, deepmerge_1.default)(this.config || {}, globalContext.config || {}, {
            isMergeableObject: is_plain_object_1.isPlainObject,
        });
        this.context = (0, deepmerge_1.default)(this.config.context || {}, globalContext || {}, {
            isMergeableObject: is_plain_object_1.isPlainObject,
        });
        if ((!(services === null || services === void 0 ? void 0 : services.client) || !(services === null || services === void 0 ? void 0 : services.tracker)) && !((_c = (_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.client) === null || _b === void 0 ? void 0 : _b.globals) === null || _c === void 0 ? void 0 : _c.siteId)) {
            throw new Error("Snap: config provided must contain a valid config.client.globals.siteId value");
        }
        this.client = (services === null || services === void 0 ? void 0 : services.client) || new snap_client_1.Client(this.config.client.globals, this.config.client.config);
        this.tracker = (services === null || services === void 0 ? void 0 : services.tracker) || new snap_tracker_1.Tracker(this.config.client.globals);
        this._controllerPromises = {};
        this._instantiatorPromises = {};
        this.controllers = {};
        // TODO environment switch using URL?
        this.logger.setMode(process.env.NODE_ENV);
        // log version
        this.logger.imageText({
            url: 'https://snapui.searchspring.io/favicon.svg',
            text: "[".concat(snap_toolbox_1.version, "]"),
            style: "color: ".concat(this.logger.colors.indigo, "; font-weight: bold;"),
        });
        try {
            var urlParams = (0, snap_toolbox_1.url)(window.location.href);
            var branchParam_1 = ((_e = (_d = urlParams.params) === null || _d === void 0 ? void 0 : _d.query) === null || _e === void 0 ? void 0 : _e.branch) || snap_toolbox_1.cookies.get(exports.BRANCH_COOKIE);
            if (branchParam_1 && !document.querySelector("script[".concat(exports.BRANCH_COOKIE, "]"))) {
                // set a cookie or localstorage with branch
                if (snap_toolbox_1.featureFlags.cookies) {
                    snap_toolbox_1.cookies.set(exports.BRANCH_COOKIE, branchParam_1, 'Lax', 3600000); // 1 hour
                    snap_toolbox_1.cookies.set(exports.SS_DEV_COOKIE, '1', 'Lax', 0);
                }
                else {
                    this.logger.warn('Cookies are not supported/enabled by this browser, branch overrides will not persist!');
                }
                this.logger.setMode(snap_logger_1.LogMode.DEVELOPMENT);
                this.logger.warn("...loading build... '".concat(branchParam_1, "'"));
                // get the path and siteId from the current bundle script in case its not the same as the client config
                var path = "https://snapui.searchspring.io/".concat(this.config.client.globals.siteId, "/");
                var script = document.querySelector('script[src*="//snapui.searchspring.io"]');
                if (script) {
                    var scriptRoot = script.getAttribute('src').match(/\/\/snapui.searchspring.io\/[a-zA-Z0-9]{6}\//);
                    if (scriptRoot) {
                        path = scriptRoot.toString();
                    }
                }
                // append script with new branch in path
                var branchScript = document.createElement('script');
                var src_1 = "".concat(path).concat(branchParam_1, "/bundle.js");
                branchScript.src = src_1;
                branchScript.setAttribute(exports.BRANCH_COOKIE, branchParam_1);
                document.head.appendChild(branchScript);
                new snap_toolbox_1.DomTargeter([
                    {
                        selector: 'body',
                        inject: {
                            action: 'append',
                            element: function () {
                                var branchContainer = document.createElement('div');
                                branchContainer.id = 'searchspring-branch-override';
                                return branchContainer;
                            },
                        },
                    },
                ], function (target, elem) { return __awaiter(_this, void 0, void 0, function () {
                    var bundleDetails, error, getBundleDetails, err_1, BranchOverride;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 3, , 4]);
                                return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('./getBundleDetails/getBundleDetails')); })];
                            case 1:
                                getBundleDetails = (_a.sent()).getBundleDetails;
                                return [4 /*yield*/, getBundleDetails(src_1)];
                            case 2:
                                bundleDetails = _a.sent();
                                return [3 /*break*/, 4];
                            case 3:
                                err_1 = _a.sent();
                                error = err_1;
                                return [3 /*break*/, 4];
                            case 4: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('./components/BranchOverride')); })];
                            case 5:
                                BranchOverride = (_a.sent()).BranchOverride;
                                (0, preact_1.render)((0, jsx_runtime_1.jsx)(BranchOverride, { name: branchParam_1, details: bundleDetails, error: error, onRemoveClick: function () {
                                        snap_toolbox_1.cookies.unset(exports.BRANCH_COOKIE);
                                        var urlState = (0, snap_toolbox_1.url)(window.location.href);
                                        delete urlState.params.query['branch'];
                                        window.location.href = urlState.url();
                                    } }), elem);
                                return [2 /*return*/];
                        }
                    });
                }); });
                // prevent further instantiation of config
                return;
            }
        }
        catch (e) { }
        if (window.searchspring) {
            window.searchspring.context = this.context;
            if (this.client)
                window.searchspring.client = this.client;
        }
        // autotrack shopper id from the context
        if ((_g = (_f = this.context) === null || _f === void 0 ? void 0 : _f.shopper) === null || _g === void 0 ? void 0 : _g.id) {
            this.tracker.track.shopper.login({
                id: this.context.shopper.id,
            });
        }
        // auto populate cart cookie from the context
        if ((_j = (_h = this.context) === null || _h === void 0 ? void 0 : _h.shopper) === null || _j === void 0 ? void 0 : _j.cart) {
            var cart = this.context.shopper.cart;
            if (Array.isArray(cart)) {
                var cartItems = cart.filter(function (item) { return (item === null || item === void 0 ? void 0 : item.sku) || (item === null || item === void 0 ? void 0 : item.childSku); }).map(function (item) { return ((item === null || item === void 0 ? void 0 : item.sku) || (item === null || item === void 0 ? void 0 : item.childSku)).trim(); });
                this.tracker.cookies.cart.set(cartItems);
            }
        }
        Object.keys(((_k = this.config) === null || _k === void 0 ? void 0 : _k.controllers) || {}).forEach(function (type) {
            switch (type) {
                case 'search': {
                    _this.config.controllers[type].forEach(function (controller, index) {
                        var _a, _b, _c, _d, _e, _f, _g, _h;
                        try {
                            var cntrlr_1 = (0, createSearchController_1.default)({
                                url: (0, deepmerge_1.default)(_this.config.url || {}, controller.url || {}),
                                controller: controller.config,
                                context: (0, deepmerge_1.default)(_this.context || {}, controller.context || {}),
                            }, {
                                client: ((_a = controller.services) === null || _a === void 0 ? void 0 : _a.client) || _this.client,
                                store: (_b = controller.services) === null || _b === void 0 ? void 0 : _b.store,
                                urlManager: (_c = controller.services) === null || _c === void 0 ? void 0 : _c.urlManager,
                                eventManager: (_d = controller.services) === null || _d === void 0 ? void 0 : _d.eventManager,
                                profiler: (_e = controller.services) === null || _e === void 0 ? void 0 : _e.profiler,
                                logger: (_f = controller.services) === null || _f === void 0 ? void 0 : _f.logger,
                                tracker: ((_g = controller.services) === null || _g === void 0 ? void 0 : _g.tracker) || _this.tracker,
                            });
                            _this.controllers[cntrlr_1.config.id] = cntrlr_1;
                            _this._controllerPromises[cntrlr_1.config.id] = new Promise(function (resolve) { return resolve(cntrlr_1); });
                            var searched_1 = false;
                            var runSearch_1 = function () {
                                if (!searched_1) {
                                    searched_1 = true;
                                    _this.controllers[controller.config.id].search();
                                }
                            };
                            var targetFunction_1 = function (target, elem, originalElem) { return __awaiter(_this, void 0, void 0, function () {
                                var onTarget, _a, Component_1, err_2;
                                var _this = this;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            runSearch_1();
                                            onTarget = target.onTarget;
                                            _a = onTarget;
                                            if (!_a) return [3 /*break*/, 2];
                                            return [4 /*yield*/, onTarget(target, elem, originalElem)];
                                        case 1:
                                            _a = (_b.sent());
                                            _b.label = 2;
                                        case 2:
                                            _a;
                                            _b.label = 3;
                                        case 3:
                                            _b.trys.push([3, 5, , 6]);
                                            return [4 /*yield*/, target.component()];
                                        case 4:
                                            Component_1 = _b.sent();
                                            setTimeout(function () {
                                                (0, preact_1.render)((0, jsx_runtime_1.jsx)(Component_1, __assign({ controller: _this.controllers[controller.config.id] }, target.props)), elem);
                                            });
                                            return [3 /*break*/, 6];
                                        case 5:
                                            err_2 = _b.sent();
                                            this.logger.error(COMPONENT_ERROR, target);
                                            return [3 /*break*/, 6];
                                        case 6: return [2 /*return*/];
                                    }
                                });
                            }); };
                            (_h = controller === null || controller === void 0 ? void 0 : controller.targeters) === null || _h === void 0 ? void 0 : _h.forEach(function (target, target_index) {
                                if (!target.selector) {
                                    throw new Error("Targets at index ".concat(target_index, " missing selector value (string)."));
                                }
                                if (!target.component) {
                                    throw new Error("Targets at index ".concat(target_index, " missing component value (Component)."));
                                }
                                if (target.prefetch) {
                                    runSearch_1();
                                }
                                cntrlr_1.createTargeter(__assign({ controller: cntrlr_1 }, target), function (target, elem, originalElem) { return __awaiter(_this, void 0, void 0, function () {
                                    var Skeleton_1;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                if (!target.skeleton) return [3 /*break*/, 2];
                                                return [4 /*yield*/, target.skeleton()];
                                            case 1:
                                                Skeleton_1 = _a.sent();
                                                setTimeout(function () {
                                                    (0, preact_1.render)((0, jsx_runtime_1.jsx)(Skeleton_1, {}), elem);
                                                });
                                                _a.label = 2;
                                            case 2:
                                                targetFunction_1(target, elem, originalElem);
                                                return [2 /*return*/];
                                        }
                                    });
                                }); });
                            });
                        }
                        catch (err) {
                            _this.logger.error("Failed to instantiate ".concat(type, " controller at index ").concat(index, "."), err);
                        }
                    });
                    break;
                }
                case 'autocomplete': {
                    _this.config.controllers[type].forEach(function (controller, index) {
                        _this._controllerPromises[controller.config.id] = new Promise(function (resolve) {
                            var _a;
                            try {
                                var bound_1 = false;
                                var runBind_1 = function () {
                                    if (!bound_1) {
                                        bound_1 = true;
                                        setTimeout(function () {
                                            _this.controllers[controller.config.id].bind();
                                        });
                                    }
                                };
                                var targetFunction_2 = function (target, elem, originalElem) { return __awaiter(_this, void 0, void 0, function () {
                                    var onTarget, _a, Component_2, err_3;
                                    var _this = this;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                onTarget = target.onTarget;
                                                _a = onTarget;
                                                if (!_a) return [3 /*break*/, 2];
                                                return [4 /*yield*/, onTarget(target, elem, originalElem)];
                                            case 1:
                                                _a = (_b.sent());
                                                _b.label = 2;
                                            case 2:
                                                _a;
                                                _b.label = 3;
                                            case 3:
                                                _b.trys.push([3, 5, , 6]);
                                                return [4 /*yield*/, target.component()];
                                            case 4:
                                                Component_2 = (_b.sent());
                                                setTimeout(function () {
                                                    (0, preact_1.render)((0, jsx_runtime_1.jsx)(Component_2, __assign({ controller: _this.controllers[controller.config.id], input: originalElem }, target.props)), elem);
                                                });
                                                return [3 /*break*/, 6];
                                            case 5:
                                                err_3 = _b.sent();
                                                this.logger.error(COMPONENT_ERROR, target);
                                                return [3 /*break*/, 6];
                                            case 6: return [2 /*return*/];
                                        }
                                    });
                                }); };
                                if (!(controller === null || controller === void 0 ? void 0 : controller.targeters) || (controller === null || controller === void 0 ? void 0 : controller.targeters.length) === 0) {
                                    _this.createController(snap_controller_1.ControllerTypes.autocomplete, controller.config, controller.services, controller.url, controller.context, function (cntrlr) {
                                        resolve(cntrlr);
                                    });
                                }
                                (_a = controller === null || controller === void 0 ? void 0 : controller.targeters) === null || _a === void 0 ? void 0 : _a.forEach(function (target, target_index) {
                                    if (!target.selector) {
                                        throw new Error("Targets at index ".concat(target_index, " missing selector value (string)."));
                                    }
                                    if (!target.component) {
                                        throw new Error("Targets at index ".concat(target_index, " missing component value (Component)."));
                                    }
                                    var targeter = new snap_toolbox_1.DomTargeter([
                                        __assign({ inject: {
                                                action: 'after',
                                                element: function () {
                                                    var acContainer = document.createElement('div');
                                                    acContainer.className = 'ss__autocomplete--target';
                                                    acContainer.addEventListener('click', function (e) {
                                                        e.stopPropagation();
                                                    });
                                                    return acContainer;
                                                },
                                            } }, target),
                                    ], function (target, elem, originalElem) { return __awaiter(_this, void 0, void 0, function () {
                                        var cntrlr;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, this.createController(snap_controller_1.ControllerTypes.autocomplete, controller.config, controller.services, controller.url, controller.context, function (cntrlr) {
                                                        resolve(cntrlr);
                                                    })];
                                                case 1:
                                                    cntrlr = _a.sent();
                                                    runBind_1();
                                                    targetFunction_2(__assign({ controller: cntrlr }, target), elem, originalElem);
                                                    cntrlr.addTargeter(targeter);
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); });
                                });
                            }
                            catch (err) {
                                _this.logger.error("Failed to instantiate ".concat(type, " controller at index ").concat(index, "."), err);
                            }
                        });
                    });
                    break;
                }
                case 'finder': {
                    _this.config.controllers[type].forEach(function (controller, index) {
                        _this._controllerPromises[controller.config.id] = new Promise(function (resolve) {
                            var _a;
                            try {
                                var searched_2 = false;
                                var runSearch_2 = function () {
                                    if (!searched_2) {
                                        _this.controllers[controller.config.id].search();
                                        searched_2 = true;
                                    }
                                };
                                var targetFunction_3 = function (target, elem, originalElem) { return __awaiter(_this, void 0, void 0, function () {
                                    var onTarget, _a, Component_3, err_4;
                                    var _this = this;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                onTarget = target.onTarget;
                                                _a = onTarget;
                                                if (!_a) return [3 /*break*/, 2];
                                                return [4 /*yield*/, onTarget(target, elem, originalElem)];
                                            case 1:
                                                _a = (_b.sent());
                                                _b.label = 2;
                                            case 2:
                                                _a;
                                                _b.label = 3;
                                            case 3:
                                                _b.trys.push([3, 5, , 6]);
                                                return [4 /*yield*/, target.component()];
                                            case 4:
                                                Component_3 = _b.sent();
                                                setTimeout(function () {
                                                    (0, preact_1.render)((0, jsx_runtime_1.jsx)(Component_3, __assign({ controller: _this.controllers[controller.config.id] }, target.props)), elem);
                                                });
                                                return [3 /*break*/, 6];
                                            case 5:
                                                err_4 = _b.sent();
                                                this.logger.error(COMPONENT_ERROR, target);
                                                return [3 /*break*/, 6];
                                            case 6: return [2 /*return*/];
                                        }
                                    });
                                }); };
                                if (!(controller === null || controller === void 0 ? void 0 : controller.targeters) || (controller === null || controller === void 0 ? void 0 : controller.targeters.length) === 0) {
                                    _this.createController(snap_controller_1.ControllerTypes.finder, controller.config, controller.services, controller.url, controller.context, function (cntrlr) {
                                        resolve(cntrlr);
                                    });
                                }
                                (_a = controller === null || controller === void 0 ? void 0 : controller.targeters) === null || _a === void 0 ? void 0 : _a.forEach(function (target, target_index) {
                                    if (!target.selector) {
                                        throw new Error("Targets at index ".concat(target_index, " missing selector value (string)."));
                                    }
                                    if (!target.component) {
                                        throw new Error("Targets at index ".concat(target_index, " missing component value (Component)."));
                                    }
                                    var targeter = new snap_toolbox_1.DomTargeter([__assign({}, target)], function (target, elem, originalElem) { return __awaiter(_this, void 0, void 0, function () {
                                        var cntrlr;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, this.createController(snap_controller_1.ControllerTypes.finder, controller.config, controller.services, controller.url, controller.context, function (cntrlr) {
                                                        resolve(cntrlr);
                                                    })];
                                                case 1:
                                                    cntrlr = _a.sent();
                                                    runSearch_2();
                                                    targetFunction_3(__assign({ controller: cntrlr }, target), elem, originalElem);
                                                    cntrlr.addTargeter(targeter);
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); });
                                });
                            }
                            catch (err) {
                                _this.logger.error("Failed to instantiate ".concat(type, " controller at index ").concat(index, "."), err);
                            }
                        });
                    });
                    break;
                }
                case 'recommendation': {
                    _this.config.controllers[type].forEach(function (controller, index) {
                        _this._controllerPromises[controller.config.id] = new Promise(function (resolve) {
                            var _a;
                            try {
                                var searched_3 = false;
                                var runSearch_3 = function () {
                                    if (!searched_3) {
                                        _this.controllers[controller.config.id].search();
                                        searched_3 = true;
                                    }
                                };
                                var targetFunction_4 = function (target, elem, originalElem) { return __awaiter(_this, void 0, void 0, function () {
                                    var onTarget, _a, Component_4, err_5;
                                    var _this = this;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                onTarget = target.onTarget;
                                                _a = onTarget;
                                                if (!_a) return [3 /*break*/, 2];
                                                return [4 /*yield*/, onTarget(target, elem, originalElem)];
                                            case 1:
                                                _a = (_b.sent());
                                                _b.label = 2;
                                            case 2:
                                                _a;
                                                _b.label = 3;
                                            case 3:
                                                _b.trys.push([3, 5, , 6]);
                                                return [4 /*yield*/, target.component()];
                                            case 4:
                                                Component_4 = _b.sent();
                                                setTimeout(function () {
                                                    (0, preact_1.render)((0, jsx_runtime_1.jsx)(Component_4, __assign({ controller: _this.controllers[controller.config.id] }, target.props)), elem);
                                                });
                                                return [3 /*break*/, 6];
                                            case 5:
                                                err_5 = _b.sent();
                                                this.logger.error(COMPONENT_ERROR, target);
                                                return [3 /*break*/, 6];
                                            case 6: return [2 /*return*/];
                                        }
                                    });
                                }); };
                                if (!(controller === null || controller === void 0 ? void 0 : controller.targeters) || (controller === null || controller === void 0 ? void 0 : controller.targeters.length) === 0) {
                                    _this.createController(snap_controller_1.ControllerTypes.recommendation, controller.config, controller.services, controller.url, controller.context, function (cntrlr) {
                                        resolve(cntrlr);
                                    });
                                }
                                (_a = controller === null || controller === void 0 ? void 0 : controller.targeters) === null || _a === void 0 ? void 0 : _a.forEach(function (target, target_index) {
                                    if (!target.selector) {
                                        throw new Error("Targets at index ".concat(target_index, " missing selector value (string)."));
                                    }
                                    if (!target.component) {
                                        throw new Error("Targets at index ".concat(target_index, " missing component value (Component)."));
                                    }
                                    var targeter = new snap_toolbox_1.DomTargeter([__assign({}, target)], function (target, elem, originalElem) { return __awaiter(_this, void 0, void 0, function () {
                                        var cntrlr;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, this.createController(snap_controller_1.ControllerTypes.recommendation, controller.config, controller.services, controller.url, controller.context, function (cntrlr) {
                                                        resolve(cntrlr);
                                                    })];
                                                case 1:
                                                    cntrlr = _a.sent();
                                                    runSearch_3();
                                                    targetFunction_4(__assign({ controller: cntrlr }, target), elem, originalElem);
                                                    cntrlr.addTargeter(targeter);
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); });
                                });
                            }
                            catch (err) {
                                _this.logger.error("Failed to instantiate ".concat(type, " controller at index ").concat(index, "."), err);
                            }
                        });
                    });
                    break;
                }
            }
        });
        if ((_m = (_l = this.config) === null || _l === void 0 ? void 0 : _l.instantiators) === null || _m === void 0 ? void 0 : _m.recommendation) {
            try {
                this._instantiatorPromises.recommendation = Promise.resolve().then(function () { return __importStar(require('./Instantiators/RecommendationInstantiator')); }).then(function (_a) {
                    var RecommendationInstantiator = _a.RecommendationInstantiator;
                    return new RecommendationInstantiator(_this.config.instantiators.recommendation, {
                        client: _this.client,
                        tracker: _this.tracker,
                        logger: _this.logger,
                    }, _this.context);
                });
            }
            catch (err) {
                this.logger.error("Failed to create Recommendations Instantiator.", err);
            }
        }
    }
    return Snap;
}());
exports.Snap = Snap;
